"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""

import re  # noqa: F401
import sys  # noqa: F401

from sifflet_sdk.client.exceptions import ApiAttributeError
from sifflet_sdk.client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    OpenApiModel,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


def lazy_import():
    from sifflet_sdk.client.model.parameterized_query_dto import ParameterizedQueryDto
    from sifflet_sdk.client.model.rule_run_values_dto import RuleRunValuesDto

    globals()["ParameterizedQueryDto"] = ParameterizedQueryDto
    globals()["RuleRunValuesDto"] = RuleRunValuesDto


class RuleRunDto(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ("incident_status",): {
            "OPEN": "OPEN",
            "IN_PROGRESS": "IN_PROGRESS",
            "CLOSED": "CLOSED",
        },
        ("status",): {
            "PENDING": "PENDING",
            "RUNNING": "RUNNING",
            "SUCCESS": "SUCCESS",
            "REQUIRES_YOUR_ATTENTION": "REQUIRES_YOUR_ATTENTION",
            "TECHNICAL_ERROR": "TECHNICAL_ERROR",
            "FAILED": "FAILED",
        },
        ("type",): {
            "MANUAL": "MANUAL",
            "SCHEDULED": "SCHEDULED",
            "DBT": "DBT",
        },
    }

    validations = {}

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (
            bool,
            date,
            datetime,
            dict,
            float,
            int,
            list,
            str,
            none_type,
        )  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            "can_show_failing_rows": (bool,),  # noqa: E501
            "debuggable": (bool,),  # noqa: E501
            "has_graph": (bool,),  # noqa: E501
            "has_group_by": (bool,),  # noqa: E501
            "id": (str,),  # noqa: E501
            "created_by": (str,),  # noqa: E501
            "created_date": (int,),  # noqa: E501
            "debug_sql": (ParameterizedQueryDto,),  # noqa: E501
            "end_date": (int,),  # noqa: E501
            "incident_issue": (int,),  # noqa: E501
            "incident_name": (str,),  # noqa: E501
            "incident_status": (str,),  # noqa: E501
            "result": (str,),  # noqa: E501
            "rule_id": (str,),  # noqa: E501
            "start_date": (int,),  # noqa: E501
            "status": (str,),  # noqa: E501
            "type": (str,),  # noqa: E501
            "values": (RuleRunValuesDto,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        "can_show_failing_rows": "canShowFailingRows",  # noqa: E501
        "debuggable": "debuggable",  # noqa: E501
        "has_graph": "hasGraph",  # noqa: E501
        "has_group_by": "hasGroupBy",  # noqa: E501
        "id": "id",  # noqa: E501
        "created_by": "createdBy",  # noqa: E501
        "created_date": "createdDate",  # noqa: E501
        "debug_sql": "debugSql",  # noqa: E501
        "end_date": "endDate",  # noqa: E501
        "incident_issue": "incidentIssue",  # noqa: E501
        "incident_name": "incidentName",  # noqa: E501
        "incident_status": "incidentStatus",  # noqa: E501
        "result": "result",  # noqa: E501
        "rule_id": "ruleId",  # noqa: E501
        "start_date": "startDate",  # noqa: E501
        "status": "status",  # noqa: E501
        "type": "type",  # noqa: E501
        "values": "values",  # noqa: E501
    }

    read_only_vars = {}

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(
        cls, can_show_failing_rows, debuggable, has_graph, has_group_by, id, *args, **kwargs
    ):  # noqa: E501
        """RuleRunDto - a model defined in OpenAPI

        Args:
            can_show_failing_rows (bool):
            debuggable (bool):
            has_graph (bool):
            has_group_by (bool):
            id (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            created_by (str): [optional]  # noqa: E501
            created_date (int): [optional]  # noqa: E501
            debug_sql (ParameterizedQueryDto): [optional]  # noqa: E501
            end_date (int): [optional]  # noqa: E501
            incident_issue (int): [optional]  # noqa: E501
            incident_name (str): [optional]  # noqa: E501
            incident_status (str): [optional]  # noqa: E501
            result (str): [optional]  # noqa: E501
            rule_id (str): [optional]  # noqa: E501
            start_date (int): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
            values (RuleRunValuesDto): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop("_check_type", True)
        _spec_property_naming = kwargs.pop("_spec_property_naming", True)
        _path_to_item = kwargs.pop("_path_to_item", ())
        _configuration = kwargs.pop("_configuration", None)
        _visited_composed_classes = kwargs.pop("_visited_composed_classes", ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                        % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.can_show_failing_rows = can_show_failing_rows
        self.debuggable = debuggable
        self.has_graph = has_graph
        self.has_group_by = has_group_by
        self.id = id
        for var_name, var_value in kwargs.items():
            if (
                var_name not in self.attribute_map
                and self._configuration is not None
                and self._configuration.discard_unknown_keys
                and self.additional_properties_type is None
            ):
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set(
        [
            "_data_store",
            "_check_type",
            "_spec_property_naming",
            "_path_to_item",
            "_configuration",
            "_visited_composed_classes",
        ]
    )

    @convert_js_args_to_python_args
    def __init__(self, can_show_failing_rows, debuggable, has_graph, has_group_by, id, *args, **kwargs):  # noqa: E501
        """RuleRunDto - a model defined in OpenAPI

        Args:
            can_show_failing_rows (bool):
            debuggable (bool):
            has_graph (bool):
            has_group_by (bool):
            id (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            created_by (str): [optional]  # noqa: E501
            created_date (int): [optional]  # noqa: E501
            debug_sql (ParameterizedQueryDto): [optional]  # noqa: E501
            end_date (int): [optional]  # noqa: E501
            incident_issue (int): [optional]  # noqa: E501
            incident_name (str): [optional]  # noqa: E501
            incident_status (str): [optional]  # noqa: E501
            result (str): [optional]  # noqa: E501
            rule_id (str): [optional]  # noqa: E501
            start_date (int): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
            values (RuleRunValuesDto): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop("_check_type", True)
        _spec_property_naming = kwargs.pop("_spec_property_naming", False)
        _path_to_item = kwargs.pop("_path_to_item", ())
        _configuration = kwargs.pop("_configuration", None)
        _visited_composed_classes = kwargs.pop("_visited_composed_classes", ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                        % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.can_show_failing_rows = can_show_failing_rows
        self.debuggable = debuggable
        self.has_graph = has_graph
        self.has_group_by = has_group_by
        self.id = id
        for var_name, var_value in kwargs.items():
            if (
                var_name not in self.attribute_map
                and self._configuration is not None
                and self._configuration.discard_unknown_keys
                and self.additional_properties_type is None
            ):
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(
                    f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                    f"class with read only attributes."
                )
